bin_packages/urls.py
from django.urls import path

from bin_packages import views


app_name = 'bin_packages'
urlpatterns = [
    path('', views.index, name='index'),
    path('<name>', views.detail, name='detail'),
]

hosts/urls.py
from django.urls import path

from hosts import views


app_name = 'hosts'
urlpatterns = [
    path('', views.index, name='index'),
    path('<name>', views.DetailView.as_view(), name='detail'),
    path('<name>/update', views.update, name='update'),
]

images/urls.py
from django.urls import path

from images import views


app_name = 'images'
urlpatterns = [
    path('', views.index, name='index'),
    path('<path:name>/update', views.update_image, name='update'),
    path('<path:name>', views.DetailView.as_view(), name='detail'),
]

kernels/urls.py
from django.urls import path

from kernels import views


app_name = 'kernels'
urlpatterns = [
    path('', views.index, name='index'),
    path('<int:os_id>_<slug:slug>', views.detail, name='detail'),
]

src_packages/urls.py
from django.urls import path

from src_packages import views


app_name = 'src_packages'
urlpatterns = [
    path('', views.index, name='index'),
    path('<name>', views.detail, name='detail'),
]

templates/base.html
<!doctype html>
<html lang="en">
  <head>
    <title>{{ title }} - DebMonitor</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    {% load static %}
    <link rel="icon" type="image/vnd.microsoft.icon" href="{% static "icons/favicon.ico" %}" sizes="16x16 32x32">

    <link rel="stylesheet" href="{% static "css/bootstrap-4.6.0.min.css" %}" integrity="sha384-4v9OgD0UeiwBGLY8Rh5KGpWxIHoDOEKsrZAqaKQEdkhHzjZDvSp1QsQo4sdOnY2t">
    <link rel="stylesheet" href="{% static "css/datatables-bs4_dt-1.10.24_fh-3.1.8.min.css" %}" integrity="sha384-/MTtGaB6yxooanB8Rj6DyDJaP1ray5d6T7e2L1wZNt6w0SwVqcVJdHE0lfu3remW"/>
    <link rel="stylesheet" href="{% static "css/main-1.0.0.css" %}" integrity="sha384-LhuZqXC/yqwnXyEG+KZWmMBLDxI4TWklVMe0b19aFeLV9nY3TCscTtT7E6biZIAR"/>
    <noscript><style nonce="{{ CSP_NONCE }}">table.hide-loading { display: table; }</style></noscript>
  </head>
  <body>
    <nav class="navbar navbar-expand-lg navbar-dark bg-dark mb-3">
      <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>

      <a class="navbar-brand" href="{% url 'index' %}">
        <img src="{% static "icons/debmonitor.svg" %}" width="30" height="30" class="d-inline-block align-top" alt="">
        DebMonitor
      </a>

      <div class="collapse navbar-collapse" id="navbarSupportedContent">
        <ul class="navbar-nav mr-auto">
          <li class="nav-item">
            <a class="nav-link{% if section == 'hosts' %} active{% endif %}" href="{% url 'hosts:index' %}">Hosts</a>
          </li>
          <li class="nav-item">
            <a class="nav-link{% if section == 'kernels' %} active{% endif %}" href="{% url 'kernels:index' %}">Kernels</a>
          </li>
          <li class="nav-item">
            <a class="nav-link{% if section == 'bin_packages' %} active{% endif %}" href="{% url 'bin_packages:index' %}">Packages</a>
          </li>
          <li class="nav-item">
            <a class="nav-link{% if section == 'src_packages' %} active{% endif %}" href="{% url 'src_packages:index' %}">Source Packages</a>
          </li>
          <li class="nav-item">
            <a class="nav-link{% if section == 'images' %} active{% endif %}" href="{% url 'images:index' %}">Images</a>
          </li>
        </ul>
        <form class="form-inline my-2 my-lg-0" action="{% url 'search' %}" method="get">
          <input name="q" pattern=".{{ "{" }}{{ SEARCH_MIN_LENGTH }},}" class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search" title="At least {{ SEARCH_MIN_LENGTH }} characters required." required>
          <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
        </form>

        {% if user.is_authenticated %}
        <div class="btn-group ml-2">
          <button class="btn btn-light dropdown-toggle" type="button" id="dropdownUserMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            <img src="{% static "icons/person.svg" %}" width="15" height="15" class="d-inline-block" alt="User Menu">
          </button>
          <div class="dropdown-menu dropdown-menu-right" aria-labelledby="dropdownUserMenuButton">
            <h6 class="dropdown-header">{{ user.username }}</h6>
            <div class="dropdown-divider"></div>
            {% if user.is_superuser %}
            <a class="dropdown-item" href="{% url 'admin:index' %}">
              <img src="{% static "icons/cog.svg" %}" width="15" height="15" class="d-inline-block" alt="">
              Admin panel
            </a>
            {% endif %}
            <a class="dropdown-item" href="{% url 'logout' %}">
              <img src="{% static "icons/account-logout.svg" %}" width="15" height="15" class="d-inline-block" alt="">
              Log out
            </a>
          </div>
        </div>
        {% endif %}

      </div>
    </nav>

    <main role="main" class="container">
      <h2 class="mb-3">{{ title }}{% if subtitle %} <small class="text-muted">- {{ subtitle }}{% endif %}</small></h2>
      <div>
        {% block summary %}{% endblock %}
      </div>
      <div>
        {% block content %}{% endblock %}
      </div>
    </main>

    <footer>
      <div class="container debmonitor-footer-container">
        <div class="row text-muted">
          <div class="col-sm-4">
          </div>
          <div class="col-sm-4 text-center">
            <a href="{% url 'index' %}">
              <img src="{% static "icons/debmonitor.svg" %}" width="30" height="30" alt="DebMonitor">
            </a>
          </div>
          <div class="col-sm-4 text-right">
            {% now "Y" as current_year %}
            &copy; 2017{% if current_year != "2017" %} - {{ current_year }}{% endif %} Wikimedia Foundation, Inc.
          </div>
        </div>
      </div>
    </footer>

    <script src="{% static "js/jquery-3.6.0.slim.min.js" %}" integrity="sha384-Qg00WFl9r0Xr6rUqNLv1ffTSSKEFFCDCKVyHZ+sVt8KuvG99nWw5RNvbhuKgif9z"></script>
    <script src="{% static "js/popper-1.16.1.min.js" %}" integrity="sha384-QxlX7wU4nxaPT6a7FYokuaf704qtz7HoR/8Z1Z3ymwNli+mE8p17sJdg+cqxfnUE"></script>
    <script src="{% static "js/bootstrap-4.6.0.min.js" %}" integrity="sha384-F8du5TjaOE2WgtAM6M1YiDZo/Q/2b5fQBZYw8OaWsU5kYKcgMT2qjwwbpY1wF71l"></script>
    <script src="{% static "js/datatables-bs4_dt-1.10.24_fh-3.1.8.min.js" %}" integrity="sha384-S07bpq0rpfCj2r52iX1agYyPD1eCsFQws5bSFU7ID12npZ1LeZ8c07NEM3kuZh01"></script>

    <script nonce="{{ CSP_NONCE }}">
    {% block bottom_script %}{% endblock %}
    $(function () {
        $('[data-toggle="tooltip"]').tooltip();
    })
    </script>
  </body>
</html>

templates/base_table.html
{% extends "./base.html" %}

{% block content %}
<table id="debmonitor-table" class="table table-sm table-hover table-striped table-borderless hide-loading" cellspacing="0" width="100%">
  <thead>
    <tr>
      {% for header in table_headers %}
      <th data-field="{{ header.title }}" data-sortable="true" class="text-nowrap"{% if forloop.first and header.badges %} id="debmonitor-th1"{% endif %}>
        {% if header.badges %}
        <div class="row">
          <div class="col-md-8"{% if forloop.first %} id="debmonitor-th1-title"{% endif %}>
            <span data-toggle="tooltip" title="{{ header.tooltip }}">{{ header.title }}</span>
          </div>
          <div class="col-md-4 px-4 debmonitor-badge-container">
          {% for badge in header.badges %}
          <button id="customSort{{ forloop.counter }}" type="button" class="btn btn-sm btn-{{ badge.style }} px-1 py-0 align-text-bottom {% if forloop.last %}active{% else %}text-secondary{% endif %} debmonitor-badge" data-toggle="tooltip" data-trigger="hover" title="{{ badge.tooltip }}" aria-pressed="true">&darr;</button>
          {% endfor %}
          </div>
        {% else %}
        <span data-toggle="tooltip" title="{{ header.tooltip }}">{{ header.title }}</span>
        {% endif %}
      </th>
      {% endfor %}
    </tr>
  </thead>
  <tbody>
    {% block table_body %}{% endblock %}
  </tbody>
</table>
{% endblock %}

{% block bottom_script %}
$(document).ready(function() {
    var table = $('#debmonitor-table').DataTable({
        'deferRender': true,
        'fixedHeader': true,
        'stateSave': true,
        'stateDuration': -1,  // Use browser's sessionStorage.
        {% if datatables_page_length %}
        'pageLength': {{ datatables_page_length }},
        {% endif %}
        'initComplete': function (settings, json) {
            $('#debmonitor-table').removeClass('hide-loading');

            {% if upgrades_column %}
            $('#debmonitor-table_wrapper > div.row:first > div').prop('class', 'col-sm-12 col-md-4')
            $('<div class="col-sm-12 col-md-4 text-left"> \
              <select class="custom-select" id="customFilterSelect"> \
                <option value="0" selected>Show all packages</option> \
                <option value="1">Show only upgradable packages</option> \
                <option value="2">Show only security upgrades</option> \
              </select> \
            </div>').insertAfter('#debmonitor-table_wrapper > div.row:first > div:first');

            var api = new $.fn.dataTable.Api(settings);
            var state = api.state.loaded();
            if (state && state.customFilterSelect) {
                $('#customFilterSelect').val(state.customFilterSelect).change();
                api.state.save();
            }

            $('#customFilterSelect').change(function() {
                switch(this.value) {
                    case "1":
                        table.search('').columns().search('');
                        table.columns({{ upgrades_column }}).search('.', true, false).draw();
                        break;
                    case "2":
                        table.search('').columns().search('');
                        table.columns({{ upgrades_column }} + 1).search('{{ security_upgrade }}', false, false).draw();
                        break;
                    default:
                        table.search('').columns().search('').draw();
                        break;
                }
            });
            {% endif %}

            {% if custom_sort %}
            $('#customSort3').addClass('active').removeClass('text-secondary');

            $('#customSort1').click(function(event) {
                event.stopPropagation();
                table.order([[{{ custom_sort.installed }}, 'desc'], [0, 'asc']]).draw();
                $(this).addClass('active').removeClass('text-secondary');
                $('#customSort2, #customSort3').removeClass('active').addClass('text-secondary');
            });
            $('#customSort2').click(function() {
                event.stopPropagation();
                table.order([[{{ custom_sort.upgrades }}, 'desc'], [{{ custom_sort.installed }}, 'desc'], [0, 'asc']]).draw();
                $(this).addClass('active').removeClass('text-secondary');
                $('#customSort1, #customSort3').removeClass('active').addClass('text-secondary');
            });
            $('#customSort3').click(function() {
                event.stopPropagation();
                table.order([[{{ custom_sort.security }}, 'desc'], [{{ custom_sort.upgrades }}, 'desc'], [{{ custom_sort.installed }}, 'desc'], [0, 'asc']]).draw();
                $(this).addClass('active').removeClass('text-secondary');
                $('#customSort1, #customSort2').removeClass('active').addClass('text-secondary');
            });
            {% endif %}
        },
        'language': {'search': 'Filter:'},
        'lengthMenu': [[50, 100, 500, -1], [50, 100, 500, 'All']],

        {% if custom_sort %}
        'order': [[{{ custom_sort.security }}, "desc"], [{{ custom_sort.upgrades }}, "desc"], [{{ custom_sort.installed }}, "desc"], [0, "asc"]],
        {% elif default_order %}
        'order': {{ default_order|safe }},
        {% else %}
        'order': [],
        {% endif %}

        {% if datatables_column_defs %}
        'columnDefs': {{ datatables_column_defs|safe }},
        {% endif %}

        {% if custom_sort or column_groups %}
        'drawCallback': function (settings) {
            {% if custom_sort %}
            if (settings.bSorted) {
                $('#customSort1, #customSort2, #customSort3').removeClass('active').addClass('text-secondary');
            }
            {% endif %}

            {% if column_groups %}
            var api = this.api();
            var rows = api.rows({page: 'current'}).nodes();
            var last = {};
            var counter = 0;
            var counters = [];

            {% for column_group in column_groups %}
            api.column({{ column_group.column }}, {page:'current'}).data().each(function (group, i) {
                if (last[{{ column_group.column }}] !== group) {
                    counters.push(counter);
                    $(rows).eq(i).before(
                        '<tr class="table-group{{ column_group.css_group }}"> \
                          <td colspan="{{ table_headers|length }}"> \
                            {{ column_group.title }}: <span class="font-weight-bold">' +
                            group +
                        '</span> <span data-toggle="tooltip" title="{{ column_group.tooltip }}"> \
                         <span id="tableGroupCounter' + counters.length + '" class="badge badge-primary align-text-bottom"></span></span></td></tr>'
                    );
                    last[{{ column_group.column }}] = group;
                    counter = 0;
                }
                counter++;
            });
            {% endfor %}
            counters.push(counter);

            $.each(counters, function(i, val) {
                $('#tableGroupCounter' + i).text(val);
            });
            {% endif %}
        },
        {% endif %}

        {% if upgrades_column %}
        'stateSaveParams': function (settings, data) {
            if ($('#customFilterSelect').length == 1) {
                data.customFilterSelect = $('#customFilterSelect').val();
            }
        },
        {% endif %}
    });
});
{% endblock %}

templates/index.html
{% extends "./base.html" %}

{% block summary %}
<div class="card-columns">
  {% for counter in counters %}
  <div class="card bg-light debmonitor-card-small">
    <h5 class="card-header">
      <a href="{% url counter.url|add:':index' %}">{{ counter.title }}</a>
      <span class="badge badge-{% if counter.count > 0 %}primary{% else %}secondary{% endif %} align-text-bottom">{{ counter.count }}</span>
    </h5>
    <ul class="list-group list-group-flush">
      {% for row in counter.rows %}
        <li class="list-group-item">
          {{ row.title|safe }}
          <span class="badge badge-{% if row.count > 0 %}{{ row.style }}{% else %}secondary{% endif %} align-text-bottom">{{ row.count }}</span>
        </li>
      {% endfor %}
    </ul>
  </div>
  {% endfor %}
</div>
{% endblock %}

{% block content %}
<hr class="bg-dark w-50"/>
<div class="card-columns">
  <div class="card bg-light debmonitor-card-small">
    <div class="card-body">
      <h6 class="card-title">Totals</h6>
      {% for total in totals %}
      <div class="card-text mb-1">
        <span>{{ total.title }}</span>
        <span data-toggle="tooltip" title="{{ total.tooltip }}" class="badge badge-{% if total.count > 0 %}{{ total.style }}{% else %}secondary{% endif %} align-text-bottom">{{ total.count }}</span>
      </div>
      {% endfor %}
    </div>
  </div>
  <div class="card bg-light debmonitor-card-small">
    <div class="card-body">
      <h6 class="card-title">Host updates</h6>
        {% for update in updates %}
        <div class="card-text">
          <span>{{ update.title }}:&nbsp;</span>
          <span data-toggle="tooltip" title="{{ update.value|date:"r" }}">{{ update.value|timesince }} ago</span>
        </div>
        {% endfor %}
    </div>
  </div>
  <div class="card bg-light debmonitor-card-small">
    <div class="card-body">
      <h6 class="card-title">Image updates</h6>
        {% for update in image_updates %}
        <div class="card-text">
          <span>{{ update.title }}:&nbsp;</span>
          <span data-toggle="tooltip" title="{{ update.value|date:"r" }}">{{ update.value|timesince }} ago</span>
        </div>
        {% endfor %}
    </div>
  </div>
</div>
{% endblock %}

templates/login.html
{% extends "./base.html" %}

{% block content %}
<div class="col-md-4 pl-0">
  <form method="post" id="login_form">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit" class="btn btn-primary">Log in</button>
  </form>
</div>
{% endblock %}

{% block bottom_script %}
$("#login_form p").addClass("form-group font-weight-bold");
$("#login_form input").addClass("form-control");
$("#login_form ul").addClass("p-0");
$("#login_form li").addClass("bg-danger text-white p-3");
{% endblock %}

templates/search.html
{% extends "./base_table.html" %}

{% block summary %}
{% if not search_results %}
<div class="alert alert-danger" role="alert">
  <h4>Invalid search query!</h4>
  <span>At least {{ SEARCH_MIN_LENGTH }} characters required.</span>
</div>
{% endif %}
{% endblock %}

{% block table_body %}
{% for search_result in search_results %}
  {% for result in search_result.results %}
  <tr>
    <td>{{ search_result.title }}</td>
    <td>
      {% if search_result.title == 'Kernels' %}
      <a href="{% url search_result.url_name result.os.id result.slug %}">{{ result.name }}</a>
      {% else %}
      <a href="{% url search_result.url_name result.name %}">{{ result.name }}{% if result.version %} ({{ result.version }} - {{ result.os__name }}){% endif %}</a>
      {% endif %}
    </td>
  </tr>
  {% endfor %}
{% endfor %}
{% endblock %}